/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2004 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#ifndef __NETSTATS_H
#define __NETSTATS_H

#define NUM_SAMPLES 10
#define SAMPLE_INTERVAL 1000

#include <snmp.h>

class NetStats
{
public:
	NetStats();
	virtual ~NetStats();

	int GetBytesPerSecIn();
	int GetBytesPerSecOut();
	BOOL IsConnAvailable();
	BOOL Start();
	void Stop();

private:
	HINSTANCE hinstInetMib;
	PFNSNMPEXTENSIONQUERY pfnSnmpExtensionQuery;
	PFNSNMPEXTENSIONINIT pfnSnmpExtensionInit;
	HANDLE hThread;
	BOOL fFirstUpdate;
	DWORD dwLastUpdateTime;
	int nSamplesIn[NUM_SAMPLES];
	int nSamplesOut[NUM_SAMPLES];
	int iSample;
	int ifInOctetsLast;
	int ifOutOctetsLast;
	int nBytesPerSecIn;
	int nBytesPerSecOut;

	void Update();
	static DWORD WINAPI ThreadProc(LPVOID pvThis);
	int GetDefRouteIfIndex();
	int GetIfStats(int ifIndex, int *ifInOctetsPtr, int *ifOutOctetsPtr);
};

#endif
