/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2004 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(__SOLIDTEXTURE_H)
#define __SOLIDTEXTURE_H

#include "Texture.h"

typedef vector<COLORREF>::iterator ColorRefIterator;

class SolidTexture : public Texture
{
public:

	SolidTexture();
	virtual ~SolidTexture();

	void configure(const string &prefix, const string &subKey);
	void apply(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType);
	void applyAnim(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType, int count) { return; };

	bool isTransparencyNeeded() { return ( (backgroundColor == RGB(255,0,255) || hoverbackgroundColor == RGB(255,0,255) || pressedbackgroundColor == RGB(255,0,255)) ? true : false); };

	bool isIconUsed() { return false; };

private:

	void parseCFG(string cfg, COLORREF &bgcolor, COLORREF &lightcolor, COLORREF &darkcolor);
	void parseGradientCFG(string cfg, int imageType);
	void solidGradientPaint(HDC destHDC, vector<COLORREF> workGradient, RECT r, bool vertical);

	int bevelSize;
	int hoverbevelSize;
	int pressedbevelSize;

	bool verticalGradient;
	bool hoververticalGradient;
	bool pressedverticalGradient;

	string gradientColor;
	COLORREF backgroundColor;
	COLORREF darkBevelColor;
	COLORREF lightBevelColor;

	string hovergradientColor;
	COLORREF hoverbackgroundColor;
	COLORREF hoverdarkBevelColor;
	COLORREF hoverlightBevelColor;

	string pressedgradientColor;
	COLORREF pressedbackgroundColor;
	COLORREF presseddarkBevelColor;
	COLORREF pressedlightBevelColor;

	vector<COLORREF> Gradient;
	vector<COLORREF> HoverGradient;
	vector<COLORREF> PressedGradient;
};

#endif
